#define Col4 A9
#define Col1 A7
#define Col2 7
#define Col3 8
#define Col4 A9
#define Col5 10
#define Row1 3
#define Row2 2
#define Row3 A6
#define Row4 5
#include "mybutton.h"
#include <Keyboard.h>


MyButton b1(Col1,String("Home"),0xC2);
MyButton b2(Col2,String("Speed 1"),0xC3);
MyButton b3(Col3,String("Speed 2"),0xC4);
MyButton b4(Col4,String("Speed 3"),0xC5);
MyButton b5(Col5,String("Spindle On"),0xC6);
MyButton b6(Col1,String("Spindle Off"),0xC7);
MyButton b7(Col2,String("Zero X"),0xC8);
MyButton b8(Col3,String("Zero Y"),0xC9);
MyButton b9(Col4,String("Zero Z"),0xCA);
MyButton b10(Col5,String("Change Tool"),0xCB);
MyButton b11(Col1,String("Warm Up"),0xCC);
MyButton b12(Col2,String("Pause"),0xCD);
MyButton b13(Col3,String("INT"),0xF0);
MyButton b14(Col4,String("Probe XYZ"),0xF1);
MyButton b15(Col5,String("Y+"),0xDA);
MyButton b16(Col1,String("Z Up"),0xF3);
MyButton b17(Col2,String("X-"),0xD8);
MyButton b18(Col3,String("Y-"),0xD9);
MyButton b19(Col4,String("X+"),0xD7);
MyButton b20(Col5,String("Z Down"),0xF4);//was 0xF7

void setup() {
 
  Serial.begin(9600);
  pinMode(Col1, INPUT_PULLUP);
  pinMode(Col2, INPUT_PULLUP);
  pinMode(Col3, INPUT_PULLUP);
  pinMode(Col4, INPUT_PULLUP);
  pinMode(Col5, INPUT_PULLUP);
  pinMode(Row1, OUTPUT);
  pinMode(Row2, OUTPUT);
  pinMode(Row3, OUTPUT);
  pinMode(Row4, OUTPUT);  
  digitalWrite(Row1, HIGH);
  digitalWrite(Row2, HIGH);
  digitalWrite(Row3, HIGH);
  digitalWrite(Row4, HIGH);
  b1.specialKey = true;
  b6.specialKey = true;
  
  Keyboard.begin();
  
}

void loop() {
  //Read Row1
  digitalWrite(Row1, LOW);
  int specialKeyCounter = 0;
  specialKeyCounter += (b1.checkButton()) ? 1 : 0;
  b2.checkButton();
  b3.checkButton();
  b4.checkButton();
  b5.checkButton();
  digitalWrite(Row1, HIGH);
  //Read Row2
  digitalWrite(Row2, LOW);
  specialKeyCounter += b6.checkButton() ? 1 : 0;
  b7.checkButton();
  b8.checkButton();
  b9.checkButton();
  b10.checkButton();
  digitalWrite(Row2, HIGH);
  //Read Row3
  digitalWrite(Row3, LOW);
  b11.checkButton();
  b12.checkButton();
  b13.checkButton();
  b14.checkButton();
  b15.checkButton();
  digitalWrite(Row3, HIGH);
  //Read Row4
  digitalWrite(Row4, LOW);
  b16.checkButton();
  b17.checkButton();
  b18.checkButton();
  b19.checkButton();
  b20.checkButton();
  digitalWrite(Row4, HIGH);
  delay(50);
  if(specialKeyCounter == 2)
  {
    Serial.println("Serial Mode");
    Keyboard.end();
    delay(10000);
  }

}


